part of text_writer;

class StringWriter implements TextWriter {
  List _line;
  List _lines = [''];
  String _newLine = '\n';
  int _row = 0;

  String get newLine {
    return _newLine;
  }

  void set newLine(String newLine) {
    switch(newLine) {
      case '\n':
      case '\r\n':
        _newLine = newLine;
        break;
      default:
        if(newLine == null) {
          _newLine = '\n';
        } else {
          throw new ArgumentError('newLine: $newLine');
        }

        break;
    }
  }

  String toString() {
    if(_line != null) {
      var start = _lines[_row];
      var end = _line.join();
      if(start.isEmpty) {
        _lines[_row] = end;
      } else {
        _lines[_row] = [start, end].join();
      }
    }

    _line = null;
    return _lines.join(_newLine);
  }

  void write(Object obj) {
    if(obj is! String) {
      obj = obj.toString();
    }

    if(_line == null) {
      _line = [obj];
    } else {
      _line.add(obj);
    }
  }

  void writeAll(Iterable objects, [String separator = ""]) {
   if(objects == null) {
     throw new ArgumentError('objects: $objects');
   }

   var list = [];
   for(var obj in objects) {
     if(obj is String) {
       list.add(obj);
     } else {
       list.add(obj.toString());
     }
   }

   if(separator != null && !separator.isEmpty) {
     write(list.join(separator));
   } else {
     write(list.join());
   }
  }

  void writeCharCode(int charCode) {
    write(new String.fromCharCode(charCode));
  }

  void writeln([Object obj]) {
    if(obj != null && obj is! String) {
      obj = obj.toString();
    }

    var start = _lines[_row];
    if(obj != null) {
      if(_line != null) {
        _line.add(obj);
      } else {
        _line = [obj];
      }
    }

    if(_line != null) {
      var end = _line.join();
      if(start.isEmpty) {
        _lines[_row] = end;
      } else {
        _lines[_row] = [start, end].join();
      }
    }

    _line = null;
    _lines.add('');
    _row++;
  }
}
